Index: /XMLIO_V2/dev/common/src/server_ym.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/server_ym.cpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/server_ym.cpp	(revision 300)
@@ -0,0 +1,381 @@
+#include "xmlioserver_spl.hpp"
+#include "cxios.hpp"
+#include "server_ym.hpp"
+#include "type.hpp"
+#include "buffer.hpp"
+#include "context.hpp"
+#include "object_template_impl.hpp"
+#include "tree_manager.hpp"
+#include "oasis_cinterface.hpp"
+#include <boost/functional/hash.hpp>
+#include <boost/algorithm/string.hpp>
+#include <mpi.h>
+
+namespace xmlioserver
+{                      
+  namespace ym
+  {
+
+    MPI_Comm CServer::intraComm ;
+    list<MPI_Comm> CServer::interComm ;
+    bool CServer::isRoot ;
+    int CServer::rank ;
+    map<string,CContext*> CServer::contextList ;    
+    bool CServer::finished=false ;
+    bool CServer::is_MPI_Initialized ;
+    
+    void CServer::initialize(void)
+    {
+      int initialized ;
+      MPI_Initialized(&initialized) ;
+      if (initialized) is_MPI_Initialized=true ;
+      else is_MPI_Initialized=false ;
+            
+      // Not using OASIS
+      if (!CXios::usingOasis)
+      {
+        
+        if (!is_MPI_Initialized) 
+        {
+          int argc=0;
+          char** argv=NULL;
+          MPI_Init(&argc,&argv) ;
+        }
+         
+        boost::hash<string> hashString ;    
+      
+        unsigned long hashServer=hashString(CXios::xiosCodeId) ;
+        unsigned long* hashAll ;
+      
+        int rank ;
+        int size ;
+        int myColor ;
+        int i,c ;
+        MPI_Comm newComm ;
+      
+        MPI_Comm_size(CXios::globalComm,&size) ;
+        MPI_Comm_rank(CXios::globalComm,&rank);
+        hashAll=new unsigned long[size] ;
+     
+        MPI_Allgather(&hashServer,1,MPI_LONG,hashAll,1,MPI_LONG,CXios::globalComm) ;
+
+        map<unsigned long, int> colors ;
+        map<unsigned long, int> leaders ;
+        map<unsigned long, int>::iterator it ;
+      
+        for(i=0,c=0;i<size;i++)
+        {
+          if (colors.find(hashAll[i])==colors.end())
+          {
+            colors[hashAll[i]]=c ;
+            leaders[hashAll[i]]=i ;
+            c++ ;
+          }
+        }
+     
+        myColor=colors[hashServer] ;
+        MPI_Comm_split(MPI_COMM_WORLD,myColor,rank,&intraComm) ;
+
+        int serverLeader=leaders[hashServer] ;
+        int clientLeader;
+     
+         serverLeader=leaders[hashServer] ;
+         for(it=leaders.begin();it!=leaders.end();it++)
+         {
+           if (it->first!=hashServer)
+           {
+             clientLeader=it->second ;
+           
+             MPI_Intercomm_create(intraComm,0,CXios::globalComm,clientLeader,0,&newComm) ;
+             interComm.push_back(newComm) ;
+           }
+         }
+
+         delete [] hashAll ;
+      }
+      // using OASIS
+      else
+      {
+        int rank ,size;
+        if (!is_MPI_Initialized) oasis_init(CXios::xiosCodeId) ;
+        oasis_get_localcomm(intraComm) ;
+        MPI_Comm_rank(intraComm,&rank) ;
+        MPI_Comm_size(intraComm,&size) ;
+        string codesId=CXios::getin<string>("oasis_codes_id") ;
+         
+        vector<string> splitted ;
+        boost::split( splitted, codesId, boost::is_space(), boost::token_compress_on ) ;
+        vector<string>::iterator it ;
+
+        MPI_Comm newComm ;
+        int globalRank ;
+        MPI_Comm_rank(CXios::globalComm,&globalRank);
+        
+        for(it=splitted.begin();it!=splitted.end();it++)
+        {
+          oasis_get_intercomm(newComm,*it) ;
+          if (rank==0) MPI_Send(&globalRank,1,MPI_INT,0,0,newComm) ;
+          MPI_Comm_remote_size(newComm,&size);
+          interComm.push_back(newComm) ;
+        }
+      }
+      
+      int rank ;
+      MPI_Comm_rank(intraComm,&rank) ;
+      if (rank==0) isRoot=true;
+      else isRoot=false; 
+      eventLoop() ;
+      finalize() ;
+    }
+    
+    void CServer::finalize(void)
+    {
+      if (!is_MPI_Initialized)
+      { 
+        if (CXios::usingOasis) oasis_finalize();
+        else MPI_Finalize() ;
+      }
+    }
+    
+     void CServer::eventLoop(void)
+     {
+       bool stop=false ;
+       
+       while(!stop)
+       {
+         if (isRoot)
+         {
+           listenContext();
+           if (!finished) listenFinalize() ;
+         }
+         else
+         {
+           listenRootContext();
+           if (!finished) listenRootFinalize() ;
+         }
+       
+         contextEventLoop() ;
+         if (finished && contextList.empty()) stop=true ;
+       }
+     
+     }
+     
+     void CServer::listenFinalize(void)
+     {
+        list<MPI_Comm>::iterator it;
+        int msg ;
+        int flag ;
+        
+        for(it=interComm.begin();it!=interComm.end();it++)
+        {
+           MPI_Status status ;
+           MPI_Iprobe(0,0,*it,&flag,&status) ;
+           if (flag==true)
+           {
+              MPI_Recv(&msg,1,MPI_INT,0,0,*it,&status) ;
+              info(20)<<" CServer : Receive client finalize"<<endl ;
+              interComm.erase(it) ;
+              break ;
+            }
+         }
+         
+         if (interComm.empty())
+         {
+           int i,size ;
+           MPI_Comm_size(intraComm,&size) ;
+           MPI_Request* requests= new MPI_Request[size-1] ;
+           MPI_Status* status= new MPI_Status[size-1] ;
+          
+           for(int i=1;i<size;i++) MPI_Isend(&msg,1,MPI_INT,i,4,intraComm,&requests[i-1]) ;
+           MPI_Waitall(size-1,requests,status) ;
+
+           finished=true ;
+           delete [] requests ;
+           delete [] status ;
+         }
+     }
+      
+     
+     void CServer::listenRootFinalize()
+     {
+        int flag ;
+        MPI_Status status ;
+        int msg ;
+        
+        MPI_Iprobe(0,4,intraComm, &flag, &status) ;
+        if (flag==true)
+        {
+           MPI_Recv(&msg,1,MPI_INT,0,4,intraComm,&status) ;
+           finished=true ;
+        }
+      }
+      
+     void CServer::listenContext(void)
+     {
+       
+       MPI_Status status ;
+       int flag ;
+       static void* buffer ;
+       static MPI_Request request ;
+       static bool recept=false ;
+       int rank ;
+       int count ;
+       
+       if (recept==false)
+       {
+         MPI_Iprobe(MPI_ANY_SOURCE,1,CXios::globalComm, &flag, &status) ;
+         if (flag==true) 
+         {
+           rank=status.MPI_SOURCE ;
+           MPI_Get_count(&status,MPI_CHAR,&count) ;
+           buffer=new char[count] ;
+           MPI_Irecv(buffer,count,MPI_CHAR,rank,1,CXios::globalComm,&request) ;
+           recept=true ;   
+         }
+       }
+       else
+       {
+         MPI_Test(&request,&flag,&status) ;
+         if (flag==true)
+         {
+           rank=status.MPI_SOURCE ;
+           MPI_Get_count(&status,MPI_CHAR,&count) ;
+           recvContextMessage(buffer,count) ;
+           delete [] buffer ;
+           recept=false ;         
+         }
+       }
+     }
+     
+     void CServer::recvContextMessage(void* buff,int count)
+     {
+ 
+       
+       static map<string,contextMessage> recvContextId ;
+       map<string,contextMessage>::iterator it ;
+       
+       CBufferIn buffer(buff,count) ;
+       string id ;
+       int clientLeader ;
+       int nbMessage ;
+
+       buffer>>id>>nbMessage>>clientLeader ;
+                       
+       it=recvContextId.find(id) ;
+       if (it==recvContextId.end())
+       {         
+         contextMessage msg={0,0} ;
+         pair<map<string,contextMessage>::iterator,bool> ret ;
+         ret=recvContextId.insert(pair<string,contextMessage>(id,msg)) ;
+         it=ret.first ;
+       }  
+       it->second.nbRecv+=1 ;
+       it->second.leaderRank+=clientLeader ;
+         
+       if (it->second.nbRecv==nbMessage)
+       { 
+         int size ;
+         MPI_Comm_size(intraComm,&size) ;
+         MPI_Request* requests= new MPI_Request[size-1] ;
+         MPI_Status* status= new MPI_Status[size-1] ;
+         
+         for(int i=1;i<size;i++)
+         {
+            MPI_Isend(buff,count,MPI_CHAR,i,2,intraComm,&requests[i-1]) ;
+         }
+         MPI_Waitall(size-1,requests,status) ;
+         registerContext(buff,count,it->second.leaderRank) ;
+
+         recvContextId.erase(it) ;
+         delete [] requests ;
+         delete [] status ;
+
+       }
+     }     
+     
+     void CServer::listenRootContext(void)
+     {
+       
+       MPI_Status status ;
+       int flag ;
+       static void* buffer ;
+       static MPI_Request request ;
+       static bool recept=false ;
+       int rank ;
+       int count ;
+       const int root=0 ;
+       
+       if (recept==false)
+       {
+         MPI_Iprobe(root,2,intraComm, &flag, &status) ;
+         if (flag==true) 
+         {
+           MPI_Get_count(&status,MPI_CHAR,&count) ;
+           buffer=new char[count] ;
+           MPI_Irecv(buffer,count,MPI_CHAR,root,2,intraComm,&request) ;
+           recept=true ;   
+         }
+       }
+       else
+       {
+         MPI_Test(&request,&flag,&status) ;
+         if (flag==true)
+         {
+           MPI_Get_count(&status,MPI_CHAR,&count) ;
+           registerContext(buffer,count) ;
+           delete [] buffer ;
+           recept=false ;         
+         }
+       }
+     } 
+     
+     
+     
+     void CServer::registerContext(void* buff,int count, int leaderRank)
+     {
+     
+       string contextId;
+       CBufferIn buffer(buff,count) ;
+
+       buffer>>contextId ;
+       MPI_Comm contextIntercomm ;
+       MPI_Intercomm_create(intraComm,0,CXios::globalComm,leaderRank,10+leaderRank,&contextIntercomm) ;
+       
+       info(20)<<"CServer : Register new Context : "<<contextId<<endl  ;
+       MPI_Comm inter ;
+       MPI_Intercomm_merge(contextIntercomm,1,&inter) ;
+       MPI_Barrier(inter) ;
+       if (contextList.find(contextId)!=contextList.end()) 
+        ERROR("void CServer::registerContext(void* buff,int count, int leaderRank)",
+              <<"Context has already been registred") ;
+      
+//      tree::CContext* ptr ;
+//      if (tree::CContext::has(contextId)) ptr=tree::CContext::get(contextId).get() ;
+//      else ptr=tree::CContext::create(contextId).get() ;
+      shared_ptr<CContext> context=tree::CTreeManager::CreateContext(contextId) ;
+      contextList[contextId]=context.get() ;
+      context->initServer(intraComm,contextIntercomm) ;
+             
+     }    
+     
+     
+     void CServer::contextEventLoop(void)
+     {
+       bool finished ;
+       map<string,CContext*>::iterator it ;
+       for(it=contextList.begin();it!=contextList.end();it++) 
+       {
+         finished=it->second->eventLoop() ;
+         if (finished)
+         {
+           contextList.erase(it) ;
+           break ;
+         }
+       }
+         
+     }
+     
+
+
+  }
+}
Index: /XMLIO_V2/dev/common/src/server_ym.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/server_ym.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/server_ym.hpp	(revision 300)
@@ -0,0 +1,45 @@
+#ifndef __SERVER_YM__HPP__
+#define __SERVER_YM__HPP__
+
+#include "xmlioserver_spl.hpp"
+#include "context.hpp"
+#include <mpi.h>
+
+namespace xmlioserver
+{
+  namespace ym
+  {
+    class CServer
+    {
+       public:
+       
+       static void initialize(void) ;
+       static void finalize(void) ;
+       static void eventLoop(void) ;
+       static void contextEventLoop(void) ;
+       static void listenContext(void) ;
+       static void listenFinalize(void) ;
+       static void recvContextMessage(void* buff,int count) ;
+       static void listenRootContext(void) ;
+       static void listenRootFinalize(void) ;
+       static void registerContext(void* buff,int count, int leaderRank=0) ;
+       
+       static MPI_Comm intraComm ;
+       static list<MPI_Comm> interComm ;
+
+       struct contextMessage
+       {
+         int nbRecv ;
+         int leaderRank ;
+       } ;
+       
+      static bool isRoot ;
+      static int rank ;
+      static map<string,CContext*> contextList ;
+      static bool finished ;
+      static bool is_MPI_Initialized ;
+    } ;
+  }
+}
+
+#endif
Index: /XMLIO_V2/dev/common/src/test/test.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/test/test.cpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/test/test.cpp	(revision 300)
@@ -0,0 +1,29 @@
+#include <iostream>
+#include <sstream>
+#include <string>
+
+using namespace std ;
+
+
+class CLog : public ostream
+{
+   public :
+   CLog() : ostream(NULL),level(0) {}
+   CLog& operator()(int l) {if (l<=level) rdbuf(cout.rdbuf()) ; else rdbuf(NULL) ; return *this;}
+   void setLevel(int l) {level=l; } 
+   int level ;
+//   ostringstream& getStream() { return *(ostringstream*)(this) ; }
+//   ~CLog(void) { cout<<"info message "<< this->str();}
+};
+
+
+int main(void)
+{
+  CLog out ;
+  cout<<string("toto")<<endl ;
+  out<<"123"<<endl ;
+  out.setLevel(5) ;
+  out(7)<<"coucou 1"<<endl ;
+  out(3)<<"coucou 2"<<endl<<"i23"<<endl ;
+  
+}
Index: /XMLIO_V2/dev/common/src/test/test_cs.f90
===================================================================
--- /XMLIO_V2/dev/common/src/test/test_cs.f90	(revision 300)
+++ /XMLIO_V2/dev/common/src/test/test_cs.f90	(revision 300)
@@ -0,0 +1,121 @@
+PROGRAM test_cs
+IMPLICIT NONE
+  INCLUDE "mpif.h"
+  INTEGER :: rank
+  INTEGER :: size
+  INTEGER :: ierr
+  
+  CALL MPI_INIT(ierr)
+  CALL MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
+  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)
+  
+  IF (rank<3) THEN
+   CALL client("client",rank,3)
+  ELSE 
+    CALL server
+  ENDIF
+  
+  
+  CALL MPI_FINALIZE(ierr)
+  
+END PROGRAM test_cs
+
+  SUBROUTINE client(id,rank,size)
+  USE xios
+  IMPLICIT NONE
+  INCLUDE 'mpif.h'
+  CHARACTER(len=*) :: id
+  INTEGER :: rank
+  INTEGER :: size
+  INTEGER :: comm
+  TYPE(xios_time)      :: dtime
+  TYPE(xios_context) :: ctx_hdl
+  INTEGER,PARAMETER :: ni_glo=10 
+  INTEGER,PARAMETER :: nj_glo=10 
+  TYPE(xios_field) :: field_hdl
+  TYPE(xios_fieldgroup) :: fieldgroup_hdl
+  TYPE(xios_file) :: file_hdl
+  
+  
+  DOUBLE PRECISION,DIMENSION(ni_glo,nj_glo) :: lon_glo,lat_glo,field_A_glo
+  DOUBLE PRECISION,ALLOCATABLE :: lon(:,:),lat(:,:),field_A(:,:)
+  INTEGER :: ni,ibegin,iend,nj,jbegin,jend
+  INTEGER :: i,j,ts,n
+  
+  DO j=1,nj_glo
+    DO i=1,ni_glo
+      lon_glo(i,j)=(i-1)+(j-1)*ni_glo
+      lat_glo(i,j)=1000+(i-1)+(j-1)*ni_glo
+      field_A_glo(i,j)=(i-1)+(j-1)*ni_glo
+    ENDDO
+  ENDDO
+  ni=ni_glo ; ibegin=1
+
+  jbegin=1
+  DO n=0,size-1
+    nj=nj_glo/size
+    IF (n<MOD(nj_glo,size)) nj=nj+1
+    IF (n==rank) exit 
+    jbegin=jbegin+nj
+  ENDDO
+  
+  iend=ibegin+ni-1 ; jend=jbegin+nj-1
+
+  ALLOCATE(lon(ni,nj),lat(ni,nj),field_A(0:ni+1,-1:nj+2))
+  lon(:,:)=lon_glo(ibegin:iend,jbegin:jend)
+  lat(:,:)=lat_glo(ibegin:iend,jbegin:jend)
+  field_A(1:ni,1:nj)=field_A_glo(ibegin:iend,jbegin:jend)
+  
+
+  CALL xios_initialize(id,local_comm=MPI_COMM_WORLD,return_comm=comm)
+
+  CALL xios_context_initialize("test",comm)
+  CALL xios_get_handle("test",ctx_hdl)
+  CALL xios_set_current_context(ctx_hdl)
+  
+  CALL xios_set_context_attr("test",calendar_type="Gregorian") 
+  CALL xios_set_context_attr("test",calendar_type="Gregorian") 
+  CALL xios_set_context_attr("test",calendar_type="Gregorian") 
+  CALL xios_set_context_attr("test",start_date="01/01/2000 - 00:00:00")
+  CALL xios_set_context_attr("test",calendar_type="Gregorian") 
+  CALL xios_set_domain_attr("domain_A",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj)
+  CALL xios_set_domain_attr("domain_A",zoom_ni=3,zoom_ibegin=3,zoom_nj=3,zoom_jbegin=6)
+  CALL xios_set_domain_attr("domain_A",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
+  CALL xios_set_domain_attr("domain_A",lonvalue=RESHAPE(lon,(/ni*nj/)),latvalue=RESHAPE(lat,(/ni*nj/)))
+  CALL xios_set_fieldgroup_attr("field_definition",enabled=.TRUE.)
+  
+  CALL xios_get_handle("field_definition",fieldgroup_hdl)
+  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
+  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
+  
+  CALL xios_get_handle("output",file_hdl)
+  CALL xios_add_child(file_hdl,field_hdl)
+  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_C")
+    
+ 
+    dtime%second=3600
+    CALL xios_set_timestep(dtime) 
+
+    CALL xios_close_context_definition()
+    DO ts=1,96
+      CALL xios_update_calendar(ts)
+      CALL xios_send_field("field_A",field_A)
+    ENDDO
+  
+    CALL xios_context_finalize()
+    CALL xios_finalize()
+     
+  END SUBROUTINE client
+  
+
+  
+  SUBROUTINE server
+  USE xios
+  IMPLICIT NONE
+  
+    CALL xios_init_server
+ 
+  END SUBROUTINE server
+  
+
+  
Index: /XMLIO_V2/dev/common/src/test/test_xios.cpp
===================================================================
--- /XMLIO_V2/dev/common/src/test/test_xios.cpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/test/test_xios.cpp	(revision 300)
@@ -0,0 +1,136 @@
+#include "xmlioserver.hpp"
+#include "attribute_template_impl.hpp"
+/*
+#include "group_template_impl.hpp"
+#include "file.hpp"
+*/
+#include "buffer_out.hpp"
+#include "buffer_in.hpp"
+#include "type.hpp"
+#include "cxios.hpp"
+#include "client_ym.hpp"
+#include "event_client.hpp"
+#include "context.hpp"
+#include "context_client.hpp"
+#include "context_server.hpp"
+#include "object_template_impl.hpp"
+#include <mpi.h>
+
+
+using namespace std ;
+using namespace ym ;
+
+int main (int argc, char ** argv, char ** UNUSED (env))
+{
+  
+  int a=3 ;
+  int b=2 ;
+  int c=1 ;
+  int buff[100] ;
+  string str("titi") ;
+   CBufferOut bufferOut(&buff,sizeof(buff)) ;
+   CBufferIn  bufferIn(&buff,sizeof(buff)) ;
+   CMessage msg ;
+/*
+   msg<<(int)3<<(int)2<<(int)1<<str ;
+//   msg<<a<<b<<c ;
+   std::cout<<"message size : "<<msg.size()<<std::endl ;
+   str="turlututu" ;
+   bufferOut<<msg ;
+   msg.clear() ;
+   msg<<a<<b<<c<<str ;
+//   bufferIn>>c>>b>>a>>str ;
+   bufferIn>>msg ;
+   std::cout<<a<<"  "<<b<<"  "<<c<<"  "<<str<<endl ;
+*/
+//   CAttributeTemplate<ARRAY(double,1)> tabIn ;
+ //  CAttributeTemplate<ARRAY(double,1)> tabOut ;
+   CAttributeTemplate<ARRAY(double,1)> tabIn("in") ;
+   CAttributeTemplate<ARRAY(double,1)> tabOut("out") ;
+
+   ARRAY_CREATE(tab,double,1,[5]) ; 
+ //   tab->resize(extents[5]) ;
+    (*tab)[0]=0 ; (*tab)[1]=1 ;(*tab)[2]=2 ; (*tab)[3]=3 ;(*tab)[4]=4 ;
+    tabIn=tab ;
+    (*tab)[0]=4 ; (*tab)[1]=3 ;(*tab)[2]=2 ; (*tab)[3]=1 ;(*tab)[4]=0 ;
+    tabOut=tab ;
+//   tabOut=1 ;
+   tabIn.toBuffer(bufferOut) ;
+   tabOut.fromBuffer(bufferIn) ;
+   
+   cout<<"attribut<Arraydouble,5>>="<<tabOut.toString()<<endl ;
+   
+   MPI_Init(&argc,&argv) ;
+   int rank ;
+   int size ;
+   char buffer[128] ;
+   
+   MPI_Comm_rank(MPI_COMM_WORLD,&rank) ;
+   if (rank>=0 && rank<=1) 
+   {
+     CXios::initClientSide("test1") ;
+     ym::CClient::registerContext("toto",ym::CClient::intraComm) ;
+//     ym::CClient::registerContext("tata",ym::CClient::intraComm) ;
+     ym::CClient::registerContext("tutu",ym::CClient::intraComm) ;
+     CObjectFactory::SetCurrentContextId("tutu") ;
+     CContext*  tutu=(CObjectFactory::GetObject<CContext>("tutu")).get(); 
+     
+     
+     CObjectFactory::SetCurrentContextId("toto") ;
+     CContext*  toto=(CObjectFactory::GetObject<CContext>("toto")).get(); 
+     toto->calendar_type.setValue("NoLeap") ;
+     toto->sendAttributToServer("calendar_type" );
+
+
+       for(int i=0;i<0;i++)
+       {
+         CMessage msg ;
+         int count ;
+         int msgSize; 
+         CEventClient event(1,1) ;
+         count=rand()%32 ;
+         msg<<string("toto")<<string(buffer,count)<<rank<<msgSize;
+         msgSize=msg.size() ;
+         event.push(0,2,msg) ;
+         event.push(1,2,msg) ;
+         toto->client->sendEvent(event) ;
+         cout<<"Send Event from toto : size "<<msgSize<<endl ;
+       }
+     toto->client->finalize() ;
+     tutu->client->finalize() ;
+     CXios::clientFinalize() ;
+   }
+   else if (rank>=2 && rank<=3) CXios::initServerSide();
+   else if (rank>=4 && rank<=6) 
+   {
+     CXios::initClientSide("test2") ;
+     ym::CClient::registerContext("tito",ym::CClient::intraComm) ;
+     CObjectFactory::SetCurrentContextId("tito") ;
+     CContext*  tito=(CObjectFactory::GetObject<CContext>("tito")).get();
+      
+     ym::CClient::registerContext("tete",ym::CClient::intraComm) ;
+     CObjectFactory::SetCurrentContextId("tete") ;
+     CContext*  tete=(CObjectFactory::GetObject<CContext>("tete")).get(); 
+
+     tito->client->finalize() ;
+     tete->client->finalize() ;
+     CXios::clientFinalize() ;
+   } 
+   else if (rank>=7 && rank<=7) 
+   {
+     CXios::initClientSide("test3") ;
+     ym::CClient::registerContext("turlututu",ym::CClient::intraComm) ;
+     CObjectFactory::SetCurrentContextId("turlututu") ;
+     CContext*  turlututu=(CObjectFactory::GetObject<CContext>("turlututu")).get(); 
+     turlututu->client->finalize() ;
+     CXios::clientFinalize() ;
+   }
+   
+   
+  
+   MPI_Barrier(MPI_COMM_WORLD); 
+   MPI_Finalize() ;
+
+  return EXIT_SUCCESS ;
+ 
+}
Index: /XMLIO_V2/dev/common/src/transfert_parameters.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/transfert_parameters.hpp	(revision 300)
+++ /XMLIO_V2/dev/common/src/transfert_parameters.hpp	(revision 300)
@@ -0,0 +1,18 @@
+#ifndef __TRANSFERT_PARAMETERS_HPP__
+#define __TRANSFERT_PARAMETERS_HPP__
+
+
+
+#define CLASS_ID_CONTEXT 1
+#define CLASS_ID_FIELD 2
+#define CLASS_ID_FILE 3
+#define CLASS_ID_AXIS 3
+#define CLASS_ID_DOMAIN 4
+#define CLASS_ID_GRID 5
+
+#define TYPE_ID_FINALIZE 2
+#define TYPE_ID_SEND_ATTR 3
+
+
+
+#endif
Index: /XMLIO_V2/dev/common/src/xmlioserver_spl.hpp
===================================================================
--- /XMLIO_V2/dev/common/src/xmlioserver_spl.hpp	(revision 299)
+++ /XMLIO_V2/dev/common/src/xmlioserver_spl.hpp	(revision 300)
@@ -20,5 +20,5 @@
 #include <map>
 #include <deque>
-
+#include <valarray>
 // Flux.
 #include <iostream>
@@ -28,5 +28,6 @@
 /// boost headers ///
 //#include <boost/unordered_map.hpp>
-
+#include <boost/shared_ptr.hpp>
+#include <boost/cast.hpp>
 /// Map ///
 #define xios_map std::map
@@ -45,6 +46,14 @@
 typedef std::size_t        StdSize;
 
+typedef  unsigned short int   ushort;
+typedef  unsigned int         uint;
+typedef  unsigned long int    ulong;
+
 /// xmlioserver headers ///
 #include "configure.hpp"
+#include "log.hpp"
+using namespace std;
+using namespace boost ;
+
 
 #endif //__XMLIO_SPL__
